#include <predef.h>
#include <stdio.h>
#include <ctype.h>
#include <startnet.h>
#include <autoupdate.h>
#include <dhcpclient.h>
#include <smarttrap.h>
#include <taskmon.h>
#include <NetworkDebug.h>
#include "PSWLevel.h"
#include <nbtime.h>

extern "C" {
void UserMain(void * pd);
}

time_t SetTime(void){
	/* Set time system clock from NTS server */
	iprintf("Getting time from NTP\r\n");
	if ( SetTimeNTPFromPool()) {
		iprintf("Time set\r\n");
	} else {
		iprintf("Failed to set time\r\n");
	}
	tzsetchar( "EST5EDT4,M3.2.0/02:00:00,M11.1.0/02:00:00" );
	/* Eastern Daylight Time (default +1) from second Sunday */
	/* in March at 2 am to first Sunday in November at 2 am.                */
	return time(NULL) + 86400; //24 hours from now
}


const char * AppName="ParrySoundWL";

void UserMain(void * pd) {
    InitializeStack();
    GetDHCPAddressIfNecessary();
    OSChangePrio(MAIN_PRIO);
    EnableAutoUpdate();
    StartHTTP();
    EnableTaskMonitor();

    #ifndef _DEBUG
    EnableSmartTraps();
    #endif

    #ifdef _DEBUG
    InitializeNetworkGDB_and_Wait();
    #endif
    SetTime();
    iprintf("\nApplication started\n");
    InitializeGetDataTask();
    while (1) {
        OSTimeDly(TICKS_PER_SECOND);
    }
}
